#include <avr/io.h>
#include <avr/interrupt.h> //Library fr Interrupts

volatile uint8_t akku;

SIGNAL(SIG_SPI) //Empfang ber SPI vollstndig, sollte auf Flag SPIF in SPSR reagieren!
{
    akku = SPCR; //Durch Auslesen der Register SPCR und SPDR Interrupt wieder freigeben
    akku = SPDR; 
    PORTC = akku; //Empfangenes Byte dezimal anzeigen. In diesem Fall die 15

    SPDR = 255; //Zusendende Dummy-Zahl in das SPI-Datenregister legen.
}

int main(void)
{
    //MOSI / PB5 als Input
    DDRB &= 0b11011111;
    //MISO / PB6 als Output (genau umgekerht wie beim Master)
    DDRB |= 0b01000000;
    //SCK / PB7 als Input (fr den Synchronisationstakt)
    DDRB &= 0b01111111;

	DDRC = 0b11111111;    //PORTC als Ausgang
    PORTC = 0;            //PORTC mit Null vorinitialisieren

    //SPI-Datenregister mit der zu sendenden Dummy-Zahl fllen:
    SPDR = 255;

    //SPI-Schnittstelle als Slave und mit Interrupt aktivieren:
    SPCR = (1<<SPIE) | (1<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);            

    //Interrupts allgemein aktivieren:
    sei();
	
	while(1) //Im Hauptprogramm nichts tun
	{
	}
	return 0;
}
